{
  "compilerOptions": {
    /*
     * The output module type (in your .js files). Node uses commonjs, so that is what we use.
     */
    "module": "commonjs",

    /*
     * Allows usage of an alternate module import syntax like `import foo from 'foo';`.
     */
    "esModuleInterop": true,

    /*
     * The output language level. Node supports ES6, so we can target that here.
     */
    "target": "es6",

    /*
     * Stricter TS settings
     */
    "noImplicitAny": true,
    "forceConsistentCasingInFileNames": true,
    "noImplicitReturns": true,
    "strict": true,
    "noUnusedLocals": true,

    /*
     * TypeScript attempts to mimic Node's module resolution strategy.
     *
     * See https://www.typescriptlang.org/docs/handbook/module-resolution.html#node
     */
    "moduleResolution": "node",

    /*
     * We want source maps to be output along side our JavaScript.
     */
    "sourceMap": true,

    /*
     * Location to output `.js` files after compilation
     */
    "outDir": "dist",

    /*
     * Part of configuring module resolution.
     */
    "baseUrl": ".",
    "paths": {
      "*": ["node_modules/*", "src/types/*"]
    },

    /*
     * Export Type Definitions together with the compiled JS code so the package can be used with both
     * TypeScript and Javascript.
     */
    "declaration": true
  },

  /*
   * Define the TypeScript project context.
   * The project context is basically a set of options that determine which files are compiled.
   */
  "include": ["src/**/*"]
}
